/*
**      Small-C Preprocessor Ver 1.1   26-Dec-87   cpp4.c
**      Nick Andrew & Jimi Hendrix
**
*/

#include        "cpp.h"

/*
**      Ifline ... Level 3 ... Ignore lines inside false conditionals
*/

ifline()
{

    iline = pline1;
    bump(0);

    for (;;) {
        whiteline();

        if (eof)
            return;

        if (ppline) {
            if (match("#if"))    {
                ++iflevel;
                if (skiplevel)
                    continue;

                if (eval_if() == 0)
                    skiplevel = iflevel;

                continue;
            }

            if (match("#ifdef"))    {
                ++iflevel;
                if (skiplevel)
                    continue;

                blanks();

                if (search(lptr, macn, NAMESIZE + 2,
                           MACNEND, MACNBR, 0) == 0)
                    skiplevel = iflevel;

                continue;
            }

            if (match("#ifndef"))   {
                ++iflevel;

                if (skiplevel)
                    continue;

                blanks();

                if (search(lptr, macn, NAMESIZE + 2,
                           MACNEND, MACNBR, 0))
                    skiplevel = iflevel;

                continue;
            }

            if (match("#else"))     {
                if (iflevel)    {
                    if (skiplevel == iflevel)
                        skiplevel = 0;
                    else if (skiplevel == 0)
                        skiplevel = iflevel;
                }
                else
                    noiferr();

                continue;
            }

            if (match("#endif"))    {
                if (iflevel)    {
                    if (skiplevel == iflevel)
                        skiplevel = 0;

                    --iflevel;
                }
                else
                    noiferr();

                continue;
            }
        }

        if (skiplevel)
            continue;

        if (listfp!=NULL) {
            lout(iline, listfp);
        }

        break;
    }
}

/*
**      Preprocess ... Level 5 ... Macro substitute an input line
*/

preprocess() {

        macdef();
        if (eof)
                return;
        macsub();
        fputs("Output from macsub: '",stderr);
        fputs(pline2,stderr);
        fputs("'\n",stderr);
}

/*
**      Macsub ... Do macro substitution from pline1 to pline2
*/

macsub()
{
    int     k,xstring,didsub;
    char    c;
    char    *from,*to;

    from = iline = pline1;
    to = oline = pline2;
    didsub = 1;

    while (didsub) {
        didsub = ocount = 0;

        bump(0);
        xstring = instring;

        while (ch)  {

            if (xstring) {

                while (ch!='"') {
                    if (ch=='\\') {
                        keepw(ch);
                        gch();
                        if (ch) keepw(ch);
                        else break;
                    }
                    else if (ch==0) {
                        error("Missing close double quote");
                        xstring = 0;
                        break;
                    }
                    else {
                        keepw(ch);
                    }
                    gch();
                }

                if (ch=='"') {
                    keepw(ch);
                    xstring = 0;
                }
                gch();
                continue;
            }

            if (ch=='\'') {
                keepw(ch);
                gch();

                while (ch!='\'') {
                    if (ch=='\\') {
                        keepw(ch);
                        gch();
                        if (ch) keepw(ch);
                        else continue;
                    }
                    else if (ch==0) {
                        error("Missing single quote (2)");
                        keepw('\'');
                        break;
                    }
                    else {
                        keepw(ch);
                    }
                    gch();
                }

                if (ch=='\'') keepw(ch);
                continue;
            }

            else if (an(ch)) {
                k = 0;

                while (an(ch) && k < NAMEMAX)  {
                    msname[k++] = ch;
                    gch();
                }

                msname[k] = 0;

                if (search(msname, macn,
                          NAMESIZE + 2, MACNEND, MACNBR, 0)) {
                    didsub = 1;
                    k = getint(cptr + NAMESIZE, 2);

                    while (c = macq[k++])
                        keepw(c);
                    while (an(ch)) gch();
                }
                else    {
                    k = 0;

                    while (c = msname[k++])
                        keepw(c);
                    while (an(ch)) {
                        keepw(ch);
                        gch();
                    }
                }
            }
            else {
                if (ch=='"') xstring = 1;
                keepw(gch());
            }
        }

        if (ocount >= LINEMAX)
            error("output line too long due to macro expansion");

        keepw(0);

        iline = to;
        oline = from;
        from = iline;
        to = oline;
    }

}

addmac()
{
    int     k;

    if (symname(msname, NO) == 0)   {
        illname();
        kill();
        return;
    }

    k = 0;

    if (search(msname, macn, NAMESIZE + 2, MACNEND, MACNBR, 0) == 0) {
        if (cptr2 = cptr)
            while (*cptr2++ = msname[k++])
                ;
        else    {
            error("macro name table full");
            return;
        }
    }

    putint(macptr, cptr + NAMESIZE, 2);

    while(white())
        gch();

    while(putmac(gch()))
        ;

    if (macptr >= MACMAX)   {
        error("macro string buffer full");
        exit(1);
    }
}

putmac(c)
char    c;
{

        macq[macptr] = c;

        if (macptr < MACMAX)
                ++macptr;

        return (c);
}

/*
**      search for symbol match
**
**      on return cptr points to slot found or empty slot
*/

search(sname, buf, len, end, max, off)
char    *sname, *buf, *end;
int     len, max, off;
        {

        cptr = cptr2 = buf + ((hash(sname) % (max - 1)) * len);

        while (*cptr != 0)      {
                if (astreq(sname, cptr + off, NAMEMAX))
                        return (1);

                if ((cptr = cptr + len) >= end)
                        cptr = buf;

                if (cptr == cptr2) {
                        cptr = NULL;
                    return 0;
            }
        }

        return 0;
}

hash(sname)
char    *sname;
        {

        xi = 0;

        while (xc = *sname++)
                xi = (xi << 1) + xc;

        return (xi);
}

outdec(number)
int     number;
        {
        int     k, zs;
        char    c;

        zs = 0;
        k = 10000;

        if (number < 0) {
                number = (-number);
                outbyte('-');
        }

        while (k >= 1)  {
                c = number / k + '0';

                if ((c != '0') | (k == 1) | (zs)) {
                        zs = 1;
                        outbyte(c);
                }

                number = number % k;
                k = k / 10;
        }
}

outstr(ptr)
char    *ptr;
        {

        while (*ptr != 0)
                outbyte(*ptr++);
}

outbyte(c)
int     c;
        {
        if (fputc(c,output) == EOF)
                xout();
        return c;
}

cout(c, fp)
char    c;
FILE    *fp;
{

        if (fputc(c, fp) == EOF)
                xout();
}

sout(string, fp)
char    *string;
FILE    *fp;
        {

        if (fputs(string, fp) == EOF)
                xout();
}

lout(line, fp)
char    *line;
FILE    *fp;
{
        sout(line, fp);
        cout('\n', fp);
}

xout()
        {
        fputs("output error\n", stderr);
        exit(1);
}

error(msg)
char    msg[];
        {

        if (errflag)
                return;

        errflag = 0;          /* always print errors */
        lout(iline, stderr);
        errout(msg, stderr);

        if (listfp != NULL)
                errout(msg, listfp);
}

errout(msg, fp)
char    msg[];
FILE    *fp;
        {
        char    *k;

        k = iline + 2;

        while (++k <= lptr) cout(' ', fp);

        lout("/\\", fp);
        sout("**** ", fp);
        lout(msg, fp);
}

streq(str1, str2)
char    str1[], str2[];
        {

        xi = 0;

        while (str2[xi]) {
                if ((str1[xi]) != (str2[xi]))
                        return (0);

                ++xi;
        }

        return (xi);
}

astreq(str1, str2, len)
char    str1[], str2[];
int     len;
        {
        int     k;

        k = 0;

        while (k < len) {
                if ((str1[k]) != (str2[k]))
                        break;

                if (str1[k] < ' ')
                        break;

                if (str2[k] < ' ')
                        break;

                ++k;
        }

        if (an(str1[k]))
                return (0);

        if (an(str2[k]))
                return (0);

        return (k);
}

match(lit)
char    *lit;
        {
        int     k;

        blanks();

        if (k = streq(lptr, lit)) {
                bump(k);
                return (1);
        }

        return (0);
}

amatch(lit, len)
char    *lit;
int     len;
        {
        int     k;

        blanks();

        if (k = astreq(lptr, lit, len)) {
                bump(k);

                while (an(ch))
                        inbyte();

                return (1);
        }

        return (0);
}

blanks()
        {

                while (ch)      {
                        if (white())
                                gch();
                        else
                                return;
                }

                return;
}

noiferr()
{
        error("no matching #if...");
        errflag = 0;
}

/*
**  macdef() ... Level 4 ... Handle macro definitions
*/

macdef() {

    for (;;) {
        ifline();

        if (eof)
            return;

        iline = pline1;
        bump(0);

        if (!ppline) return;

        if (match("#define"))  addmac();
        else
            if (match("#undef"))   doundef();
        else
            return;
    }
}

doundef()
{
    int     k;

    if (symname(msname, NO) == 0) {
        illname();
        return;
    }

    k = 0;

    if (search(msname, macn, NAMESIZE+2, MACNEND, MACNBR, 0) == 0) {
        error("Not a defined macro");
        return;
    }

    *cptr = 1;    /* make the slot unusable */

}

